using System;
using System.Collections.Generic;
using System.Text;
using ceTe.DynamicPDF;
using ceTe.DynamicPDF.PageElements;
using ceTe.DynamicPDF.Merger;
using ceTe.DynamicPDF.Text;
using System.Configuration;
using System.Globalization;

namespace Consulenza.PDFLettera
{ 
    public class LetteraAccettazioneConAttivazioneSei : LetteraBenvenuto {

        public LetteraAccettazioneConAttivazioneSei (string rete, int id, string testo, string nome, string cognome, string indirizzo, string appellativo, string obj, string firma)
            : base(rete,id, testo, nome, cognome,indirizzo,false,appellativo,obj,firma) {
            this.settaCampi();
            this.nomeLettera = "LetteraAccettazioneConAttivazioneSei" + id;
            
        }

        protected override void settaCampi() {
            this.cliente.Text = this.appellativo + "\r\n" + nome + " " + cognome + "\r\n" + indirizzo;
            DateTimeFormatInfo dfi = new CultureInfo("it-IT", false).DateTimeFormat;
            this.luogo.Text = "Roma, " + dataGenerazione.ToString("dd MMMM yyyy", new CultureInfo("it-IT", false).DateTimeFormat);
            this.oggetto.Text = this.testoOggetto; 
            this.corpo.Text = testo;
            string[] valoriTextArea = ConfigurationManager.AppSettings["OffsetFirmaAttivazioneSei"].Split(',');            
            this.saluti.Text = this.testoSaluti;
           
        }

    }
}