﻿namespace Consulenza.ReportCommon
{
    /// <summary>
    /// Rappresentazione del PrivateBanker.
    /// </summary>
    public class PrivateBanker
    {
        /// <summary>
        /// Imposta o recupera il nominativo del private banker.
        /// </summary>
        public string Nominativo { get; set; }

        /// <summary>
        /// Imposta o recupera il codice della rete del private banker.
        /// </summary>
        public string CodiceRete { get; set; }

        /// <summary>
        /// Imposta o recupera il codice del private banker.
        /// </summary>
        public string Codice { get; set; }

        /// <summary>
        /// Imposta o recupera l'indirizzo del private banker.
        /// </summary>
        public string Indirizzo { get; set; }

        /// <summary>
        /// Imposta o recupera il numero civico dell'indirizzo del private banker.
        /// </summary>
        public string NumeroCivico { get; set; }

        /// <summary>
        /// Imposta o recupera il cap dell'indirizzo del private banker.
        /// </summary>
        public string Cap { get; set; }

        /// <summary>
        /// Imposta o recupera la citta di provenienza del private banker.
        /// </summary>
        public string Citta { get; set; }

        /// <summary>
        /// Imposta o recupera il prefisso telefonico del private banker.
        /// </summary>
        public string PrefissoTelefono { get; set; }

        /// <summary>
        /// Imposta o recupera il numero telefonico del private banker.
        /// </summary>
        public string Telefono { get; set; }

        /// <summary>
        /// Imposta o recupera il livello del private banker. Mappato dalla colonna livello della tabella PromotoreBancario
        /// </summary>
        public string Livello { get; set; }

        /// <summary>
        /// Imposta o recupera il codice agente del manager del private banker. Mappato dalla colonna codManager della tabella PromotoreBancario
        /// </summary>
        public string CodiceManager { get; set; }
    }
}
