﻿using System.Collections.Generic;
using Consulenza.ReportWriter.Business.Entity;
using ceTe.DynamicPDF;
using System;

namespace Consulenza.ReportWriter.Business.OBJ_PDF
{
    /// <summary>
    /// Rappresenta un oggetto contenitore di Elements.
    /// </summary>
    public class CompositePDF : ObjectPDF
    {
        /// <summary>
        /// Ottiene o imposta la lista di ObjectPDF che saranno renderizzati.
        /// </summary>
        public List<ObjectPDF> Elements { get; set; }

        /// <summary>
        /// Costruttore
        /// </summary>
        public CompositePDF()
        {
        }

        /// <summary>
        /// Costruttore
        /// </summary>
        /// <param name="elements"></param>
        public CompositePDF(List<ObjectPDF> elements)
        {
            Elements = elements;
            ObjectType = ObjectTypePdf.COMPOSITE;
        }

        /// <summary>
        /// Ritorna l'oggetto che sarà stampato sulla pagina del documento.
        /// </summary>
        /// <returns></returns>
        public override PageElement ToElement()
        {
            throw new NotImplementedException();
        }
    }
}
