﻿using Consulenza.ReportWriter.Business.Entity;

namespace Consulenza.ReportWriter.Business.OBJ_PDF
{
    /// <summary>
    /// Rappresenta uno spazio vuoto.
    /// La dimensione dello spazio è data dalla proprietà _height.
    /// </summary>
    public class SpacePDF : ObjectPDF
    {
        #region Fields

        public ceTe.DynamicPDF.PageElement BaseElement { get; set; }

        /// <summary>
        /// Ottiene o imposta l'altezza dello spazio vuoto.
        /// </summary>
        public float Height { get; set; }

        #endregion

        #region Costruttori

        /// <summary>
        /// Costruttore
        /// </summary>
        public SpacePDF()
        {
            Height = 0;
            ObjectType = ObjectTypePdf.SPACE;
        }

        /// <summary>
        /// Costruttore
        /// </summary>
        /// <param name="space">Altezza dello spazio vuoto</param>
        public SpacePDF(float space)
            : this()
        {
            Height = space;
        }

        #endregion

        #region Metodi

        /// <summary>
        /// Ritorna l'oggetto che sarà stampato sulla pagina del documento.
        /// </summary>
        /// <returns></returns>
        public override ceTe.DynamicPDF.PageElement ToElement()
        {
            return BaseElement;
        }       

        #endregion
    }
}
