﻿using Consulenza.ReportWriter.Business;
using Consulenza.ReportWriter.Business.OBJ_PDF;
using Consulenza.ReportWriter.Business.CUSTOM_PDF.ConsulenzaUnica;
using System;

namespace Consulenza.ReportWriter.Manager.Chapter.Unica
{
    /// <summary>
    /// Scheda 4. Patrimonio finanziario: rappresentazione per intermediario. idCapitolo 22
    /// </summary>
    public class S4 : Entity.Chapter
    {
        public S4(EnvironmentFacade environmentFacade, int idChapter)
            : base(environmentFacade, idChapter)
        {
            try
            {
                Draw();
            }
            catch (Exception ex)
            {
                SectionLogger.Write("S4", ex.Message, SectionLoggerMessageLevel.E, EnvironmentFacade.ReportEnvironment);
            }
        }

        public S4(EnvironmentFacade environmentFacade, int idChapter, bool repeatoneachpage)
            : this(environmentFacade, idChapter)
        {
            RepeatOnEachPage = repeatoneachpage;
        }      

        protected override sealed void Draw()
        {
            // Aggiungo la pagina
            AddElement(new PagePDF(PagePDF.PagePDFType.Generic));

            var testi = GetText();

            var intestazione = new ChapterHeadingPDF(
                testi.Rows[0]["testo1"].ToString(),               
                EnvironmentFacade.RendererFacade.XLeftLimit,
                EnvironmentFacade.RendererFacade.YUpperLimit,
                EnvironmentFacade.ReportEnvironment.FontFamily);

            // Aggiungo gli elementi
            AddElement(intestazione.ToElement());
        }
    }
}
