﻿using Consulenza.ReportWriter.Business;
using Consulenza.ReportWriter.Business.OBJ_PDF;
using Consulenza.ReportWriter.Business.CUSTOM_PDF.ConsulenzaUnica;
using System;

namespace Consulenza.ReportWriter.Manager.Chapter.Unica
{
    /// <summary>
    /// Glossario - IdCapitolo = 92
    /// </summary>
    public class S74 : Entity.Chapter
    {
        public S74(EnvironmentFacade environmentFacade, int idChapter)
            : base(environmentFacade, idChapter)
        {
            Draw();
        }

        public S74(EnvironmentFacade environmentFacade, int idChapter, bool repeatoneachpage)
            : this(environmentFacade, idChapter)
        {
            RepeatOnEachPage = repeatoneachpage;
        }

        protected override void Draw()
        {
            //Aggiungo la pagina
            AddElement(new PagePDF(PagePDF.PagePDFType.Generic));
            var testi = GetText();
            var intestazione = new ChapterHeadingPDF(
                testi.Rows[0]["testo1"].ToString(),
                EnvironmentFacade.RendererFacade.XLeftLimit,
                EnvironmentFacade.RendererFacade.YUpperLimit,
                EnvironmentFacade.ReportEnvironment.FontFamily
                );

            // Aggiungo gli elementi
            AddElement(intestazione.ToElement());
        }
    }
}
