﻿using System;
using Consulenza.ReportWriter.Business;
using Consulenza.ReportWriter.Business.OBJ_PDF;
using System.Data;
using Consulenza.ReportCommon;
using Consulenza.ReportWriter.Manager.Integration;

namespace Consulenza.ReportWriter.Manager.Section.Unica.Nucleo
{
    /// <summary>
    ///S31.PatrimonioAltriIstitutiDettaglioProdotti  idSezione = 74
    /// </summary>
    public class S31 : Unica.S31
    {
        public S31(EnvironmentFacade environmentFacade, int idSection)
            : base(environmentFacade, idSection)
        {
           
        }

        public override string getTestoIntro()
        {
            string testo = "";
            string banca = "$/Banca/$";
            banca = /*"altri Istituti";*/ banca.Replace("$/Banca/$", Helper.ReplaceVariables("$/Banca/$", EnvironmentFacade.ReportEnvironment));
            if(raggruppamentoCategoria())
                //testo = "In questa scheda sono riportati i prodotti, associati al nucleo, che i componenti detengono presso " + banca + ", raggruppati secondo le categorie di appartenenza, con indicazione del relativo intermediario.";
                testo = "In questa scheda sono riportati i prodotti, associati al nucleo, che i componenti detengono presso altri Istituti, raggruppati secondo le categorie di appartenenza, con indicazione del relativo intermediario.";
            else
                testo = "In questa scheda sono riportati i prodotti, associati al nucleo, che i componenti detengono presso " + NomeIntermediario + ", raggruppati secondo le categorie di appartenenza.";
            
            return testo;

        }

        public override bool raggruppamentoCategoria()
        {
            return GetOption<Opzione6>().Valore.Equals("S");
        }
    }
}
