﻿using System;
using Consulenza.ReportWriter.Business;
using Consulenza.ReportWriter.Business.OBJ_PDF;
using System.Data;
using Consulenza.ReportCommon;

namespace Consulenza.ReportWriter.Manager.Section.Unica.Nucleo
{
    public class S40 : Unica.S40
    {
        /// <summary>
        ///S40.Adeguatezza  idSezione = 83
        /// </summary>
        public S40(EnvironmentFacade environmentFacade, int idSection)
            : base(environmentFacade, idSection)
        {
            
        }

        public override string getTesto1() {
            return datiSeiUnico.FormatBanca("Di seguito sono riportati i risultati della valutazione di adeguatezza del patrimonio associato al nucleo, che i componenti detengono presso $/Banca/$, in riferimento a tutti gli indicatori di rischio che $/Banca/$ utilizza per valutare l'adeguatezza degli investimenti. Per ogni indicatore, ove previsti, sono riportati il livello massimo associato al profilo finanziario attribuito al nucleo, e il valore relativo al patrimonio associato al nucleo che i componenti detengono presso $/Banca/$, con indicazione del corrispondente grado di copertura.");
        }//getTesto1

        public override string getTesto3()
        {
            string nota = "Nella tabella sottostante sono riportati i prodotti, associati al nucleo, che i componenti detengono presso $/Banca/$, con evidenza dei principali indicatori di rischio.";
            string token = "";
            switch (GetOption<Opzione6_2>().RaggruppaProdotti)
            {
                case RaggruppaProdotti.AreaBisogno:
                    nota += token + "I prodotti sono raggruppati per area di bisogno.";
                    token = " ";
                    break;
                case RaggruppaProdotti.Categoria:
                    nota += token +"I prodotti sono raggruppati secondo la categoria di appartenenza.";
                    token = " ";
                    break;
                case RaggruppaProdotti.Contratto:
                    nota += token +"I prodotti sono raggruppati secondo il contratto di appartenenza.";
                    token = " ";
                    break;
            }
            return datiSeiUnico.FormatBanca(nota);
        }//getTesto3

        public override string getTesto4()
        {
            return datiSeiUnico.FormatBanca("In questa scheda sono riportati i risultati della valutazione di adeguatezza del patrimonio associato al nucleo, che i componenti detengono presso $/Banca/$, in riferimento all'indicatore di concentrazione. Per gli emittenti e i fondi speculativi presenti nel nucleo sono riportati, ove previsti, il confronto tra il controvalore \"attuale\" e il controvalore sotto il quale non si applica il controllo di concentrazione (\"franchigia\"), e il confronto tra la concentrazione \"attuale\" e la soglia massima definita dal modello di adeguatezza.");
        }//getTesto4

        public override string getTesto6()
        {
            string cliente = "";//FARE
            return datiSeiUnico.FormatBanca("In questa scheda sono riportati i risultati della valutazione di adeguatezza del patrimonio associato al nucleo, che i componenti detengono presso $/Banca/$, in riferimento all'indicatore di liquidità/liquidabilità. Nel grafico sono indicate l'area di adeguatezza e l'area di non adeguatezza: la prima individua le situazioni in cui le caratteristiche di durata e di liquidità dei prodotti associati al nucleo, che i componenti detengono presso $/Banca/$, sono coerenti con gli orizzonti temporali di investimento derivanti dalle risposte fornite alla domanda 9 del questionario di profilatura, dal cliente " + cliente + ", il cui profilo finanziario è stato attribuito al nucleo.");
        }//getTesto6
    }
}
